diff --git a/src/components/swarm/agent-picker.tsx b/src/components/swarm/agent-picker.tsx
new file mode 100644
index 0000000..7197534
--- /dev/null
+++ b/src/components/swarm/agent-picker.tsx
@@ -0,0 +1,131 @@
+"use client";
+
+import React from 'react';
+import { X, Blocks, Check, Pencil, Plus } from 'lucide-react';
+import type { AgentArchetype } from '../../lib/types-swarm';
+import { getArchetypeDisplayChar } from '../../lib/utils';
+
+interface AgentPickerProps {
+    archetypes: AgentArchetype[];
+    isOpen: boolean;
+    onClose: () => void;
+    onSelect: (archetype: AgentArchetype) => void;
+    onEdit: (archetypeId: string) => void;
+    onCreateNew: () => void;
+}
+
+export function AgentPicker({
+    archetypes,
+    isOpen,
+    onClose,
+    onSelect,
+    onEdit,
+    onCreateNew
+}: AgentPickerProps) {
+    if (!isOpen) return null;
+
+    const handleBackdropClick = (e: React.MouseEvent) => {
+        if (e.target === e.currentTarget) {
+            onClose();
+        }
+    };
+
+    const handleSelect = (archetype: AgentArchetype) => {
+        onSelect(archetype);
+        onClose();
+    };
+
+    return (
+        <div
+            className="fixed inset-0 z-50 flex items-center justify-center bg-black/60 backdrop-blur-sm p-4 animate-in fade-in duration-200"
+            onClick={handleBackdropClick}
+        >
+            <div className="flex flex-col w-full max-w-[800px] max-h-[85vh] overflow-hidden rounded-xl border border-[var(--ui-border-soft)] bg-[#0f1824] shadow-2xl animate-in zoom-in-95 duration-200">
+                <div className="flex items-center justify-between border-b border-[var(--ui-border-soft)] px-5 py-4 bg-[#14202e]">
+                    <div className="flex items-center gap-3">
+                        <Blocks className="w-5 h-5 text-[var(--ui-text-secondary)]" />
+                        <h2 className="text-lg font-bold text-[var(--ui-text-primary)]">
+                            Select Archetype
+                        </h2>
+                    </div>
+                    <button
+                        onClick={onClose}
+                        className="rounded-full p-2 text-[var(--ui-text-muted)] hover:bg-white/5 hover:text-white transition-colors"
+                    >
+                        <X className="w-5 h-5" />
+                    </button>
+                </div>
+
+                <div className="flex-1 overflow-y-auto px-4 py-4">
+                    {archetypes.length === 0 ? (
+                        <div className="flex flex-col items-center justify-center py-12 text-[var(--ui-text-muted)]">
+                            <Blocks className="w-12 h-12 mb-3 opacity-50" />
+                            <p className="text-sm">No archetypes available</p>
+                            <p className="text-xs mt-1">Create one to get started</p>
+                        </div>
+                    ) : (
+                        <div className="grid grid-cols-2 gap-4">
+                            {archetypes.map((archetype) => {
+                                const displayChar = getArchetypeDisplayChar(archetype);
+                                return (
+                                    <div
+                                        key={archetype.id}
+                                        className="group relative flex flex-col p-4 rounded-xl bg-[var(--ui-bg-soft)] border border-[var(--ui-border-soft)] hover:border-[var(--ui-border)] hover:bg-[#111f2b] transition-all duration-200"
+                                    >
+                                        <div className="flex items-start gap-3 mb-2">
+                                            <div
+                                                className="h-10 w-10 rounded-xl flex items-center justify-center text-lg font-bold border-2 flex-shrink-0"
+                                                style={{
+                                                    backgroundColor: `${archetype.color}20`,
+                                                    color: archetype.color,
+                                                    borderColor: `${archetype.color}50`
+                                                }}
+                                            >
+                                                {displayChar}
+                                            </div>
+                                            <div className="flex-1 min-w-0">
+                                                <h3 className="font-semibold text-[var(--ui-text-primary)] text-sm truncate">
+                                                    {archetype.name}
+                                                </h3>
+                                                <p className="text-xs text-[var(--ui-text-muted)] line-clamp-4 mt-0.5">
+                                                    {archetype.description || 'No description'}
+                                                </p>
+                                            </div>
+                                        </div>
+
+                                        <div className="flex items-center gap-2 mt-auto pt-2 border-t border-[var(--ui-border-soft)]">
+                                            <button
+                                                onClick={() => handleSelect(archetype)}
+                                                className="flex-1 flex items-center justify-center gap-1.5 px-3 py-1.5 rounded-lg bg-blue-600 text-white text-xs font-medium hover:bg-blue-500 transition-colors"
+                                            >
+                                                <Check className="w-3.5 h-3.5" />
+                                                Select
+                                            </button>
+                                            <button
+                                                onClick={() => onEdit(archetype.id)}
+                                                className="p-1.5 rounded-lg text-[var(--ui-text-muted)] hover:text-[var(--ui-text-primary)] hover:bg-white/5 transition-colors"
+                                                title="Edit archetype"
+                                            >
+                                                <Pencil className="w-3.5 h-3.5" />
+                                            </button>
+                                        </div>
+                                    </div>
+                                );
+                            })}
+                        </div>
+                    )}
+                </div>
+
+                <div className="border-t border-[var(--ui-border-soft)] px-5 py-4 bg-[#14202e]">
+                    <button
+                        onClick={onCreateNew}
+                        className="w-full flex items-center justify-center gap-2 px-4 py-2.5 rounded-lg bg-[var(--ui-bg-soft)] border border-[var(--ui-border-soft)] text-[var(--ui-text-secondary)] hover:bg-[#111f2b] hover:text-[var(--ui-text-primary)] hover:border-[var(--ui-border)] transition-colors"
+                    >
+                        <Plus className="w-4 h-4" />
+                        Create New Archetype
+                    </button>
+                </div>
+            </div>
+        </div>
+    );
+}
diff --git a/src/components/swarm/swarm-workspace.tsx b/src/components/swarm/swarm-workspace.tsx
index 7d50f93..6f612d8 100644
--- a/src/components/swarm/swarm-workspace.tsx
+++ b/src/components/swarm/swarm-workspace.tsx
@@ -8,7 +8,7 @@ import { cn, getArchetypeDisplayChar, getTemplateDisplayChar, getTemplateColor }
 import type { BeadIssue } from '../../lib/types';
 import { useArchetypes } from '../../hooks/use-archetypes';
 import { useTemplates } from '../../hooks/use-templates';
-import { ArchetypeInspector } from './archetype-inspector';
+import { AgentInspector } from './agent-inspector';
 import { TemplateInspector } from './template-inspector';
 
 export function SwarmWorkspace({ selectedMissionId, issues = [], projectRoot }: { selectedMissionId?: string, issues?: BeadIssue[], projectRoot: string }) {
@@ -276,13 +276,13 @@ export function SwarmWorkspace({ selectedMissionId, issues = [], projectRoot }:
                                             <div className="text-[10px] uppercase font-bold text-[var(--ui-text-muted)] tracking-wider mb-2">Team Composition</div>
                                             <div className="flex flex-wrap gap-2">
                                                 {tpl.team.map((member, idx) => {
-                                                    const arch = archetypes.find(a => a.id === member.archetypeId);
+                                                    const arch = archetypes.find(a => a.id === member.agentTypeId);
                                                     return (
                                                         <div key={idx} className="flex items-center gap-1.5 px-2 py-1 rounded-md bg-[#0f1824] border border-[var(--ui-border-soft)]">
                                                             <div className="h-4 w-4 rounded text-[9px] flex items-center justify-center font-bold" style={{ backgroundColor: `${arch?.color || '#888'}20`, color: arch?.color || '#888' }}>
                                                                 {arch ? getArchetypeDisplayChar(arch) : '?'}
                                                             </div>
-                                                            <span className="text-[11px] text-[var(--ui-text-primary)] font-medium">{member.count}x {arch?.name || member.archetypeId}</span>
+                                                            <span className="text-[11px] text-[var(--ui-text-primary)] font-medium">{member.count}x {arch?.name || member.agentTypeId}</span>
                                                         </div>
                                                     );
                                                 })}
@@ -350,7 +350,7 @@ export function SwarmWorkspace({ selectedMissionId, issues = [], projectRoot }:
 
             {/* Popups */}
             {inspectingArchetypeId !== null && (
-                <ArchetypeInspector
+                <AgentInspector
                     archetype={archetypes.find(a => a.id === inspectingArchetypeId)}
                     onClose={() => setInspectingArchetypeId(null)}
                     onSave={saveArchetype}
diff --git a/src/components/swarm/template-inspector.tsx b/src/components/swarm/template-inspector.tsx
index 921fea5..27ec745 100644
--- a/src/components/swarm/template-inspector.tsx
+++ b/src/components/swarm/template-inspector.tsx
@@ -34,7 +34,10 @@ export function TemplateInspector({ template, archetypes, onClose, onSave, onDel
 
     const [name, setName] = useState(template?.name || '');
     const [description, setDescription] = useState(template?.description || '');
-    const [team, setTeam] = useState<{ archetypeId: string; count: number }[]>(template?.team || []);
+    // Use agentTypeId internally, normalize from template.team
+    const [team, setTeam] = useState<{ agentTypeId: string; count: number }[]>(
+        template?.team?.map(m => ({ agentTypeId: m.agentTypeId, count: m.count })) || []
+    );
     const [protoFormula, setProtoFormula] = useState(template?.protoFormula || '');
     const [color, setColor] = useState(template?.color || '#f59e0b');
     const [icon, setIcon] = useState(template?.icon || '');
@@ -49,26 +52,26 @@ export function TemplateInspector({ template, archetypes, onClose, onSave, onDel
         if (template) {
             setName(template.name);
             setDescription(template.description);
-            setTeam(template.team);
+            setTeam(template.team?.map(m => ({ agentTypeId: m.agentTypeId, count: m.count })) || []);
             setProtoFormula(template.protoFormula || '');
             setColor(template.color || '#f59e0b');
             setIcon(template.icon || '');
         }
     }, [template]);
 
-    const updateTeamMember = (index: number, field: 'archetypeId' | 'count', value: string | number) => {
+    const updateTeamMember = (index: number, field: 'agentTypeId' | 'count', value: string | number) => {
         const newTeam = [...team];
         if (field === 'count') {
             newTeam[index] = { ...newTeam[index], count: Math.max(1, Number(value)) };
         } else {
-            newTeam[index] = { ...newTeam[index], archetypeId: value as string };
+            newTeam[index] = { ...newTeam[index], agentTypeId: value as string };
         }
         setTeam(newTeam);
     };
 
     const addTeamMember = () => {
-        const firstAvailableArchetype = archetypes[0]?.id || '';
-        setTeam([...team, { archetypeId: firstAvailableArchetype, count: 1 }]);
+        const firstAvailableAgentType = archetypes[0]?.id || '';
+        setTeam([...team, { agentTypeId: firstAvailableAgentType, count: 1 }]);
     };
 
     const removeTeamMember = (index: number) => {
@@ -328,8 +331,8 @@ export function TemplateInspector({ template, archetypes, onClose, onSave, onDel
                             {team.map((member, index) => (
                                 <div key={index} className="flex items-center gap-2">
                                     <select
-                                        value={member.archetypeId}
-                                        onChange={(e) => updateTeamMember(index, 'archetypeId', e.target.value)}
+                                        value={member.agentTypeId}
+                                        onChange={(e) => updateTeamMember(index, 'agentTypeId', e.target.value)}
                                         className="flex-1 bg-[#0a111a] border border-[var(--ui-border-soft)] rounded-md px-3 py-2 text-sm text-[var(--ui-text-primary)] focus:outline-none focus:border-[var(--ui-accent-info)]"
                                     >
                                         {archetypes.map(a => (
@@ -403,11 +406,11 @@ export function TemplateInspector({ template, archetypes, onClose, onSave, onDel
                                             key={idx}
                                             className="px-2 py-0.5 rounded-full text-[10px] font-medium"
                                             style={{ 
-                                                backgroundColor: `${getArchetypeColor(member.archetypeId)}20`, 
-                                                color: getArchetypeColor(member.archetypeId)
+                                                backgroundColor: `${getArchetypeColor(member.agentTypeId)}20`, 
+                                                color: getArchetypeColor(member.agentTypeId)
                                             }}
                                         >
-                                            {getArchetypeName(member.archetypeId)} ×{member.count}
+                                            {getArchetypeName(member.agentTypeId)} ×{member.count}
                                         </span>
                                     ))}
                                 </div>
diff --git a/src/hooks/use-url-state.ts b/src/hooks/use-url-state.ts
index 2ea355e..1513341 100644
--- a/src/hooks/use-url-state.ts
+++ b/src/hooks/use-url-state.ts
@@ -3,10 +3,13 @@
 import { useCallback, useEffect, useMemo, useState } from 'react';
 import { useSearchParams, useRouter } from 'next/navigation';
 
-export type ViewType = 'social' | 'graph' | 'activity';
+export type ViewType = 'social' | 'graph';
 export type PanelState = 'open' | 'closed';
 export type DrawerState = 'open' | 'closed';
 export type GraphTabType = 'flow' | 'overview';
+export type LeftSidebarMode = 'epics' | 'orchestrator';
+export type LeftPanelStatusFilter = 'all' | 'ready' | 'in_progress' | 'blocked' | 'deferred' | 'done';export type LeftPanelPriorityFilter = 'all' | 'P0' | 'P1' | 'P2' | 'P3' | 'P4';export type LeftPanelPresetFilter = 'all' | 'active' | 'blocked_agents';export interface LeftPanelFilters {  status: LeftPanelStatusFilter;  priority: LeftPanelPriorityFilter;  preset: LeftPanelPresetFilter;  hideClosed: boolean;
+  query: string;}
 
 export interface UrlState {
   view: ViewType;
@@ -22,6 +25,9 @@ export interface UrlState {
   leftPanel: PanelState;
   setLeftPanel: (state: PanelState) => void;
   toggleLeftPanel: () => void;
+  leftSidebarMode: LeftSidebarMode;
+  setLeftSidebarMode: (mode: LeftSidebarMode) => void;
+  toggleLeftSidebarMode: () => void;
   rightPanel: PanelState;
   setRightPanel: (state: PanelState) => void;
   toggleRightPanel: () => void;
@@ -42,11 +48,13 @@ const DEFAULT_LEFT_PANEL: PanelState = 'open';
 const DEFAULT_RIGHT_PANEL: PanelState = 'open';
 const DEFAULT_DRAWER: DrawerState = 'closed';
 const DEFAULT_GRAPH_TAB: GraphTabType = 'overview';
+const DEFAULT_LEFT_SIDEBAR_MODE: LeftSidebarMode = 'epics';
 
-const VALID_VIEWS: ViewType[] = ['social', 'graph', 'activity'];
+const VALID_VIEWS: ViewType[] = ['social', 'graph'];
 const VALID_PANELS: PanelState[] = ['open', 'closed'];
 const VALID_DRAWERS: DrawerState[] = ['open', 'closed'];
 const VALID_GRAPH_TABS: GraphTabType[] = ['flow', 'overview'];
+const VALID_LEFT_SIDEBAR_MODES: LeftSidebarMode[] = ['epics', 'orchestrator'];
 
 const PANEL_STORAGE_KEYS = {
   left: 'bb.ui.leftPanel',
@@ -78,6 +86,13 @@ function isBlockedEnabled(value: string | null): boolean {
   return value === '1' || value === 'true';
 }
 
+function parseLeftSidebarMode(value: string | null): LeftSidebarMode {
+  if (!value || !VALID_LEFT_SIDEBAR_MODES.includes(value as LeftSidebarMode)) {
+    return DEFAULT_LEFT_SIDEBAR_MODE;
+  }
+  return value as LeftSidebarMode;
+}
+
 export function parseUrlState(
   searchParams: URLSearchParams,
   defaults: PanelDefaults = {
@@ -91,6 +106,7 @@ export function parseUrlState(
   agentId: string | null;
   epicId: string | null;
   leftPanel: PanelState;
+  leftSidebarMode: LeftSidebarMode;
   rightPanel: PanelState;
   blockedOnly: boolean;
   panel: PanelState;
@@ -114,6 +130,7 @@ export function parseUrlState(
   const leftPanel = leftPanelFromUrl ?? defaults.leftPanel;
   const rightPanel = rightPanelFromUrl ?? legacyPanel ?? defaults.rightPanel;
   const panel = rightPanel;
+  const leftSidebarMode = parseLeftSidebarMode(searchParams.get('leftMode'));
 
   const blockedOnly = isBlockedEnabled(searchParams.get('blocked'));
 
@@ -127,7 +144,7 @@ export function parseUrlState(
     ? (graphTabParam as GraphTabType)
     : DEFAULT_GRAPH_TAB;
 
-  return { view, taskId, swarmId, agentId, epicId, leftPanel, rightPanel, blockedOnly, panel, drawer, graphTab };
+  return { view, taskId, swarmId, agentId, epicId, leftPanel, leftSidebarMode, rightPanel, blockedOnly, panel, drawer, graphTab };
 }
 
 export function buildUrlParams(
@@ -190,6 +207,14 @@ export function useUrlState(): UrlState {
     setLeftPanel(state.leftPanel === 'open' ? 'closed' : 'open');
   }, [setLeftPanel, state.leftPanel]);
 
+  const setLeftSidebarMode = useCallback((mode: LeftSidebarMode) => {
+    updateUrl({ leftMode: mode });
+  }, [updateUrl]);
+
+  const toggleLeftSidebarMode = useCallback(() => {
+    setLeftSidebarMode(state.leftSidebarMode === 'epics' ? 'orchestrator' : 'epics');
+  }, [setLeftSidebarMode, state.leftSidebarMode]);
+
   const setRightPanel = useCallback((next: PanelState) => {
     // Keep legacy `panel` in sync while migrating to explicit `right`.
     updateUrl({ right: next, panel: next });
@@ -259,6 +284,9 @@ export function useUrlState(): UrlState {
     leftPanel: state.leftPanel,
     setLeftPanel,
     toggleLeftPanel,
+    leftSidebarMode: state.leftSidebarMode,
+    setLeftSidebarMode,
+    toggleLeftSidebarMode,
     rightPanel: state.rightPanel,
     setRightPanel,
     toggleRightPanel,
diff --git a/src/lib/agent-instance.ts b/src/lib/agent-instance.ts
new file mode 100644
index 0000000..b7b2292
--- /dev/null
+++ b/src/lib/agent-instance.ts
@@ -0,0 +1,72 @@
+/**
+ * Agent Instance Model
+ * 
+ * An Agent Instance is a running copy of an Agent Type.
+ * When spawned, it gets a numbered instance (e.g., "Engineer 01", "Engineer 02").
+ */
+
+export interface AgentInstance {
+  /** Unique instance ID (e.g., "engineer-01-abc123") */
+  id: string;
+  /** What kind of agent this is (e.g., "engineer", "architect") */
+  agentTypeId: string;
+  /** Display name for UI (e.g., "Engineer 01") */
+  displayName: string;
+  /** Current status of this instance */
+  status: 'spawning' | 'working' | 'idle' | 'completed' | 'failed';
+  /** The bead/task this agent is working on */
+  currentBeadId?: string;
+  /** When this instance was spawned */
+  startedAt: string;
+  /** When this instance completed/failed */
+  completedAt?: string;
+  /** Result summary for completed agents */
+  result?: string;
+  /** Error message for failed agents */
+  error?: string;
+}
+
+export interface AgentStatus {
+  /** Total number of active agents */
+  totalActive: number;
+  /** Count by agent type { "engineer": 2, "architect": 1 } */
+  byType: Record<string, number>;
+  /** All active instances */
+  instances: AgentInstance[];
+}
+
+/**
+ * Generate a unique agent instance ID.
+ * Format: {agentTypeId}-{number}-{random}
+ */
+export function generateAgentInstanceId(agentTypeId: string, instanceNumber: number): string {
+  const suffix = String(instanceNumber).padStart(2, '0');
+  const random = Math.random().toString(36).slice(2, 8);
+  return `${agentTypeId}-${suffix}-${random}`;
+}
+
+/**
+ * Get display name for an agent instance.
+ * Format: "{AgentTypeName} {number}" (e.g., "Engineer 01")
+ */
+export function getAgentDisplayName(agentTypeName: string, instanceNumber: number): string {
+  const num = String(instanceNumber).padStart(2, '0');
+  return `${agentTypeName} ${num}`;
+}
+
+/**
+ * Parse an instance ID to extract its components.
+ */
+export function parseAgentInstanceId(instanceId: string): {
+  agentTypeId: string;
+  instanceNumber: number;
+  random: string;
+} | null {
+  const match = instanceId.match(/^([a-z-]+)-(\d{2})-([a-z0-9]+)$/);
+  if (!match) return null;
+  return {
+    agentTypeId: match[1],
+    instanceNumber: parseInt(match[2], 10),
+    random: match[3],
+  };
+}
diff --git a/src/lib/agent-persistence.ts b/src/lib/agent-persistence.ts
new file mode 100644
index 0000000..47cbc4f
--- /dev/null
+++ b/src/lib/agent-persistence.ts
@@ -0,0 +1,93 @@
+/**
+ * Agent Instance Persistence
+ * 
+ * Persists agent instances to disk so they survive app restarts.
+ * Uses .beads/agents.jsonl for storage.
+ */
+
+import fs from 'fs/promises';
+import path from 'path';
+import type { AgentInstance } from './agent-instance';
+
+const AGENTS_FILE = (projectRoot: string) => path.join(projectRoot, '.beads', 'agents.jsonl');
+
+/**
+ * Load all agent instances from disk.
+ */
+export async function loadAgentInstances(projectRoot: string): Promise<AgentInstance[]> {
+  try {
+    const content = await fs.readFile(AGENTS_FILE(projectRoot), 'utf-8');
+    return content
+      .trim()
+      .split('\n')
+      .filter(Boolean)
+      .map(line => JSON.parse(line));
+  } catch {
+    return [];
+  }
+}
+
+/**
+ * Save a new agent instance to disk.
+ */
+export async function saveAgentInstance(projectRoot: string, instance: AgentInstance): Promise<void> {
+  const agentsPath = AGENTS_FILE(projectRoot);
+  await fs.mkdir(path.dirname(agentsPath), { recursive: true });
+  
+  const line = JSON.stringify(instance) + '\n';
+  await fs.appendFile(agentsPath, line, 'utf-8');
+}
+
+/**
+ * Update an existing agent instance in place.
+ */
+export async function updateAgentInstance(projectRoot: string, instance: AgentInstance): Promise<void> {
+  const agentsPath = AGENTS_FILE(projectRoot);
+  const instances = await loadAgentInstances(projectRoot);
+  
+  const idx = instances.findIndex(i => i.id === instance.id);
+  if (idx >= 0) {
+    instances[idx] = instance;
+    await fs.writeFile(
+      agentsPath,
+      instances.map(i => JSON.stringify(i)).join('\n') + '\n',
+      'utf-8'
+    );
+  }
+}
+
+/**
+ * Get only active instances (spawning, working, idle).
+ */
+export async function getActiveInstances(projectRoot: string): Promise<AgentInstance[]> {
+  const all = await loadAgentInstances(projectRoot);
+  return all.filter(i => 
+    i.status === 'spawning' || 
+    i.status === 'working' || 
+    i.status === 'idle'
+  );
+}
+
+/**
+ * Get recent completed/failed instances for history.
+ */
+export async function getRecentInstances(projectRoot: string, limit = 20): Promise<AgentInstance[]> {
+  const all = await loadAgentInstances(projectRoot);
+  return all
+    .filter(i => i.status === 'completed' || i.status === 'failed')
+    .sort((a, b) => 
+      new Date(b.completedAt || 0).getTime() - new Date(a.completedAt || 0).getTime()
+    )
+    .slice(0, limit);
+}
+
+/**
+ * Clear all agent instances (for testing/reset).
+ */
+export async function clearAgentInstances(projectRoot: string): Promise<void> {
+  try {
+    await fs.unlink(AGENTS_FILE(projectRoot));
+  } catch {
+    // File doesn't exist, that's fine
+  }
+}
diff --git a/src/lib/agent-workspace.ts b/src/lib/agent-workspace.ts
new file mode 100644
index 0000000..2dfe101
--- /dev/null
+++ b/src/lib/agent-workspace.ts
@@ -0,0 +1,41 @@
+import { listProjects } from './registry';
+import { resolveProjectScope } from './project-scope';
+
+export interface ResolveAgentWorkspaceOptions {
+  currentProjectRoot?: string;
+  requestedProjectKey?: string | null;
+  requestedProjectRoot?: string | null;
+}
+
+export interface ResolvedAgentWorkspace {
+  root: string;
+  key: string;
+  source: 'explicit-root' | 'scope-selection';
+}
+
+export async function resolveAgentWorkspace(options: ResolveAgentWorkspaceOptions = {}): Promise<ResolvedAgentWorkspace> {
+  const currentProjectRoot = options.currentProjectRoot ?? process.cwd();
+
+  if (options.requestedProjectRoot && options.requestedProjectRoot.trim()) {
+    const root = options.requestedProjectRoot.trim();
+    return {
+      root,
+      key: root.toLowerCase(),
+      source: 'explicit-root',
+    };
+  }
+
+  const registryProjects = await listProjects();
+  const scope = resolveProjectScope({
+    currentProjectRoot,
+    registryProjects,
+    requestedProjectKey: options.requestedProjectKey ?? null,
+    requestedMode: 'single',
+  });
+
+  return {
+    root: process.platform === 'win32' ? scope.selected.root : scope.selected.displayPath,
+    key: scope.selected.key,
+    source: 'scope-selection',
+  };
+}
